//
//  Item.c
//  folder
//
//  Created by kunii on 2013/11/18.
//  Copyright (c) 2013年 國居貴浩. All rights reserved.
//

#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#include "Item.h"

//  Item構造体を初期化する。
//      nameに9バイト以上の文字列をわたしてはいけない
static Item* initItem(Item* item, const char* name)
{
	item->name = malloc(strlen(name) + 1);
    strcpy(item->name, name);       //  nameに指定される名前をコピーする
    return item;
}

//  itemで指定されるItem構造体の名前をコンソールに表示する。
static void printItem(Item* item, int indent)
{
    //  Itemは何もしない
}

//  Item構造体を破棄する。
void deallocItem(Item* item)
{
	free(item->name);
    free(item); //  itemが示すItem構造体用に確保したメモリ領域を破棄する
}

Item* ItemAlloc()
{
    Item* item = malloc(sizeof(Item));
    item->init = initItem;
    item->print = printItem;
    item->dealloc = deallocItem;
    return item;
}
